#pragma semicolon 1

#include <sourcemod>

#define PLUGIN_VERSION "1.0"

public Plugin:myinfo =
{
	name = "NameChecker - MySQL",
	author = "Fire-Games.ru",
	description = "Block bad nicknames",
	version = PLUGIN_VERSION,
	url = "http://fire-games.ru/"
};

#define MAX_BADNICKS 64

new Handle:db = INVALID_HANDLE;
new Handle:g_Enabled = INVALID_HANDLE;
new Handle:g_Prefix = INVALID_HANDLE;
new Handle:g_DatabaseConfig = INVALID_HANDLE;

new String:sm_namechecker_mysql_prefix[32];
new String:sm_namechecker_mysql_dbconfig[32];

new NicksCount = 0;
new String:BadNick[MAX_BADNICKS][64];
new String:KickReason[MAX_BADNICKS][128];

public OnPluginStart()
{
	CreateConVar("sm_namechecker_mysql_version", PLUGIN_VERSION, "NameChecker on MySQL", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
   	g_Enabled = CreateConVar("sm_namechecker_mysql_enable", "1", "Enables this plugin");
   	g_Prefix = CreateConVar("sm_namechecker_mysql_prefix", "namechecker", "Table prefix in database");
   	g_DatabaseConfig = CreateConVar("sm_namechecker_mysql_dbconfig", "namechecker", "Name of database config in database.cfg");
   	AutoExecConfig(true, "namechecker_mysql");
    }
public OnConfigsExecuted()
{
	GetConVarString(g_Prefix, sm_namechecker_mysql_prefix, 32);
	GetConVarString(g_DatabaseConfig, sm_namechecker_mysql_dbconfig, 32);
        if (db != INVALID_HANDLE) CloseHandle(db);
        ConnectToMysql();
}
stock MysqlStart()
{
    NicksCount = 0;
    new String:sql[128];
    Format(sql, sizeof(sql), "SELECT nick,text_to_kick FROM %s_nicks", sm_namechecker_mysql_prefix);
    new Handle:hQuery = SQL_Query(db, sql);
    if (hQuery == INVALID_HANDLE) {
        LogError("Query failed! %s", sql);
    } else {
    new String:nick[64];
    while (SQL_FetchRow(hQuery))
	{
        SQL_FetchString(hQuery, 0, nick, 64);
        BadNick[NicksCount] = nick;
        SQL_FetchString(hQuery, 1, KickReason[NicksCount], 128);
        NicksCount++;
	}
    }
}
public bool:OnClientConnect(client, String:rejectmsg[], maxlen)
{
    if (!GetConVarBool(g_Enabled))	return true;
    new String:name[64];
    GetClientName(client, name, sizeof(name));
    for (new i = 0; i < NicksCount; i++) {
        if (StrContains(name, BadNick[i], false) > -1) {
			new String:query[128];
			Format(query, sizeof(query), "UPDATE %s_nicks SET kicks=kicks+1 WHERE nick = '%s'", sm_namechecker_mysql_prefix, BadNick[i]);
			SQL_FastQuery(db, query);
			strcopy(rejectmsg, maxlen, KickReason[i]);
			return false;
        }
    }
    return true;
}
 
public OnPluginEnd()
{
    if(db != INVALID_HANDLE){
        CloseHandle(db);
    }
}
stock ConnectToMysql(){
    SQL_TConnect(OnSqlConnect,sm_namechecker_mysql_dbconfig);
}
public OnSqlConnect(Handle:owner, Handle:hndl, const String:error[], any:data)
{
    if (hndl == INVALID_HANDLE)
	{
		LogError("Database connect failure: %s", error);
		LogError("plugins/namechecker_mysql.smx was unloaded");
 		ServerCommand("sm plugins unload namechecker_mysql");
	} else {
        db = hndl;
        decl String:buffer[1024];
        Format(buffer, sizeof(buffer), "CREATE TABLE IF NOT EXISTS `%s_nicks` (`nick` varchar(64) NOT NULL,`text_to_kick` varchar(128) NOT NULL,`kicks` int(4) NOT NULL DEFAULT '0',PRIMARY KEY (`nick`)) DEFAULT CHARSET=utf8;", sm_namechecker_mysql_prefix);
        SQL_FastQuery(db, buffer);
        FormatEx(buffer, sizeof(buffer), "SET NAMES \"UTF8\"");
        SQL_Query(db, buffer);
        MysqlStart();
	}
}
